/*  Copyright (C) 2017 Nicholas C. Strauss (strauss@positive-internet.com)
    This file is part of ORBTIMES.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "startime.h"
//#include "date_expression.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

/*
  output in tm 
*/
double
parse_date (const char *input)
{
  struct tm     atm;
  const char   *cp, *month_name[]={"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"};
  char         *success;
  double        jd;
  //  success = getdate_r (input, &atm);
  memset(&atm, 0, sizeof(atm));


  success = strptime (input, "%Y-%m-%d", &atm); 
  if (!success) success = strptime (input, "%Y-%B-%d", &atm);     
  else printf("Error: ISO 8601 date format year-month-date\n");
  printf("Input Date: %d-%s-%d\n", 1900+atm.tm_year, month_name[atm.tm_mon], atm.tm_mday);
  // Convert date into internal Julian timestamp.
  jd = JulianDays(atm.tm_mday, atm.tm_mon+1, 1900+atm.tm_year);
  return jd;
}
