/*  Copyright (C) 2017 Nicholas C. Strauss (strauss@positive-internet.com)
    This file is part of ORBTIMES.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  location_expression.h
  Definition of the structure used to build the syntax tree.
 */
#ifndef __LOCATIONEXPRESSION_H__
#define __LOCATIONEXPRESSION_H__

typedef struct taglocationExpression
{
  double    lat, lon, elevation;
} locationExpression;


locationExpression *allocate_locationExpression();
void delete_locationExpression(locationExpression *b);
locationExpression *createLocation(double latitude, double longitude, double elevation=0.0);
double createLatitudeLongitude(char *latitude,char posidir);
double createLatitudeLongitudeDecimal(char *latitude,char posidir);
double createLatitudeLongitudeSec(char *latitude,char posidir);
double createElevation(char *elevation);
double createElevationFeet(char *elevation);

#endif // __LOCATIONEXPRESSION_H__
